#include <stdint.h>
#include <libopencm3/stm32/rcc.h>
#include <libopencm3/stm32/gpio.h>
#include "tm1637.h"

uint32_t receive_data (void);
uint16_t counter = 0;
uint8_t count;
uint32_t data = 0;

int main(void) {
    rcc_clock_setup_in_hse_8mhz_out_48mhz();
    rcc_periph_clock_enable(RCC_GPIOA);
    gpio_mode_setup(GPIOA, GPIO_MODE_INPUT, GPIO_PUPD_PULLUP, GPIO0);    // Пин PA0 на вход
    tm1637Init();
    gpio_mode_setup(GPIOA, GPIO_MODE_OUTPUT, GPIO_PUPD_NONE, GPIO12);   // Мигаем PA12
    //uint32_t Tled = 0;
    while (1) {
        while (gpio_get (GPIOA, GPIO0));
        while (!(gpio_get (GPIOA, GPIO0)));
        counter = receive_data();
        tm1637DisplayDecimal(counter, 0);
        gpio_toggle(GPIOA, GPIO12);
    }
    return 0;
}//


uint32_t receive_data (void) {
uint32_t code=0;
    while (!(gpio_get (GPIOA, GPIO0)));     // wait for the pin to go high.. 9ms LOW
    while ((gpio_get (GPIOA, GPIO0)));        // wait for the pin to go low.. 4.5ms HIGH
    for (int i=0; i<32; i++) {
        count=0;
        while (!(gpio_get (GPIOA, GPIO0))); // wait for pin to go high.. this is 562.5us LOW
        while (gpio_get (GPIOA, GPIO0)) { // count the space length while the pin is high
            count++;
            delay_us(50);
        }
        if (count > 12) { // if the space is more than 1.2 ms
            code |= (1UL << (31-i));   // write 1
        }
        else code &= ~(1UL << (31-i));  // write 0
    }
    return code;
}
